import os
import zipfile
import urllib.request as request

class Installer:
    def __init__(self):
        self.__BIN_FOLDER= "bin/"
        self.__temp_zip_file_name=self.__BIN_FOLDER+"temp_zip_file.zip"
    
    def get_driver(self, url):
        self.__clear_bin()
        zip_file_path= self.__retrieve_zip_file(url)
        self.__extract_and_delete_zip(zip_file_path)
        driver_path= self.__get_driver_path()
        return driver_path
        
    def __retrieve_zip_file(self, url):
        try:
            zip_file_path, _= request.urlretrieve(url, self.__temp_zip_file_name)
        except Exception as ex:
            print("Failed to retrieve driver zip file")
            raise ex
        return zip_file_path
    
    def __extract_and_delete_zip(self, zip_file_path):
        zip_file_reader= zipfile.ZipFile(zip_file_path, 'r')
        zip_file_reader.extractall(self.__BIN_FOLDER)
        zip_file_reader.close()
        os.remove(self.__temp_zip_file_name)

    def __get_driver_path(self):
         for file in os.listdir(self.__BIN_FOLDER):
            return self.__BIN_FOLDER+file
    
    def __clear_bin(self):
        for file in os.listdir(self.__BIN_FOLDER):
            os.remove(self.__BIN_FOLDER+file)

# if __name__=="__main__":
#     url= 'https://github.com/adieuadieu/serverless-chrome/releases/download/v1.0.0-29/stable-headless-chromium-amazonlinux-2017-03.zip'
#     driver_path=Installer()._get_driver(url)
#     print(driver_path)